package RPM::Source::Convert::Plugins::DistroMap::CheckDB;
use strict;
use warnings;
use Carp;

use Source::Shared::Resource::DistroMap;
use RPM::Source::Transformation::Factory;
use RPM::Source::Transformation::OptHandlerWrapper;
our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

our $verbose;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	    -priority => PRIORITY_PRECONVERT,
	    -name => 'distromap_check_db',
	    -opt_handler_sub=>\&opt_handler_distromap_check_db);
}

my %KNOWN_DB=map{$_=>1} qw/
fedora
mageia
suse
/;
# TODO:
#rosa
#pld

sub opt_handler_distromap_check_db {
    my (undef,undef,undef,$opt,$resourceobj)=@_;
    my $distromap=$resourceobj->get_distromap;
    my $repo=$distromap->dest()->{-repo};
    $distromap->die_if_no_distromap('binary') if $KNOWN_DB{$repo};
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
