package RPM::Source::Convert::Plugins::OtherLang;
use strict;
use warnings;

use RPM::Source::Tools::Dependency::Filter;
use RPM::Source::Transformation::Factory;
use RPM::Source::Transformation::OptHandlerWrapper;
use RPM::Source::Transformation::Factory::DependencyFilter;

our @ISA=qw/RPM::Source::Transformation::Factory/;
push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

our $verbose=0;

sub transformations {
    return 
	RPM::Source::Transformation::OptHandlerWrapper->new(
	    -priority => PRIORITY_CONVERT,
	    -name => 'generic_lang_related_convert',
	    -opt_handler_sub=>\&opt_handler_otherlang_convert),
	;
}

sub opt_handler_otherlang_convert {
    my (undef,$spec,undef,$opt,$resourceobj)=@_;
    my $macros=$spec->macros();
    my $mainsec=$spec->main_section;
    my $buildreq=$resourceobj->buildreq;

    my ($flag_macro_tcl,$flag_macro_ruby,);
    foreach my $sec ($spec->get_sections()) {
	my $t = $sec->get_type();
	next if $t eq 'changelog';
	# if ($t eq 'build') {
	#     $sec->map_body(sub {
	# 		   });
	# } elsif ($t eq 'install') {
	#     $sec->map_body(sub {
	# 		   });

	# } elsif ($t eq 'files') {
	#     $sec->map_body(sub {
	# 		   } );
	# }

#	$sec->map_body(sub {
#	} ) if ($t eq 'install' or $t eq 'build' or $t eq 'prep' or $t eq 'check');



	# general hacks here
	$sec->map_body(sub {

	    if (
		s,(?<!%)\%\{tcl_sitelib\},%{_tcllibdir},g or
		s,(?<!%)\%tcl_sitelib\b,%_tcllibdir,g) {
		$flag_macro_tcl=1;
	    }

	    if (/\%\{?ruby_vendor(?:arch|lib)dir\}?/) {
		s,\%\{ruby_vendorlibdir\},%{ruby_sitelibdir},g;
		s,\%ruby_vendorlibdir,%ruby_sitelibdir,g;
		s,\%\{ruby_vendorarchdir\},%{ruby_sitearchdir},g;
		s,\%ruby_vendorarchdir,%ruby_sitearchdir,g;
		$flag_macro_ruby=1;
	    }
	} );

    }
    $buildreq->add_pre_buildreq('rpm-build-ruby') if $flag_macro_ruby;
    $buildreq->add_pre_buildreq('rpm-build-tcl') if $flag_macro_tcl;
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
