#!/usr/bin/perl -w

use strict;
use warnings;

use Cwd;
use File::Find;
use RPM::Header;

my @cpio_unpack_cmd=qw!pax -O -r!;
my $cpio_unpack_cmd=join(' ',@cpio_unpack_cmd);
my $outdir = getcwd;

sub unpack_rpm {
    my ($rpmarg)=@_;
    my $rhref=new RPM::Header $rpmarg;
    my $specname;
    my $total_files=scalar(@{$rhref->{'FILEFLAGS'}});
    #SPEC files have flag 32
    for (my $i=0;$i<$total_files;$i++) {
	$specname = $rhref->{'BASENAMES'}[$i] if (@{$rhref->{'FILEFLAGS'}}[$i] == 32);
    }
    #print STDERR "unpacking $specname from $rpmarg\n";
    #print STDERR "rpm2cpio '$rpmarg' | $cpio_unpack_cmd $specname\n";

    system("rpm2cpio '$rpmarg' | $cpio_unpack_cmd $specname") && die "rpm2cpio failed on srpm $rpmarg";
    my $nvrname=join('-',$rhref->NVR()).'.spec';
    #system('pwd');
    #print STDERR "mv $specname $nvrname \n";
    system('mv', $specname, $outdir.'/'.$nvrname) && die "mv $specname $outdir/$nvrname failed at ", getcwd();
}

find(\&wanted,  @ARGV);

sub wanted {
    &unpack_rpm($File::Find::name) if /\.src.rpm$/;
}
